// Heap.c
// Runs on any computer
// A fixed-block memory manager
// Valvano
// August 21, 2011

/* This example accompanies the book
   "Embedded Systems: Real Time Interfacing to the Arm Cortex M3",
   ISBN: 978-1463590154, Jonathan Valvano, copyright (c) 2011
   Program 3.11

 Copyright 2011 by Jonathan W. Valvano, valvano@mail.utexas.edu
    You may use, edit, run or distribute this file
    as long as the above copyright notice remains
 THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 VALVANO SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 For more information about my classes, my research, and my books, see
 http://users.ece.utexas.edu/~valvano/
 */

#define SIZE 80      
#define NUM 5      
#define NULL 0  // empty pointer
char *FreePt; 
char Heap[SIZE*NUM];

void Heap_Init(void){ 
char *pt;
  FreePt = &Heap[0];
  for(pt=&Heap[0];
      pt!=&Heap[SIZE*(NUM-1)];
      pt=pt+SIZE){ 
    *(long*)pt =(long)(pt+SIZE); 
  }
  *(long*)pt = NULL; 
}
void *Heap_Allocate(void){
char *pt;
  pt = FreePt;
  if (pt != NULL){ 
    FreePt = (char*) *(char**)pt;
  }
  return(pt);
}

void Heap_Release(void *pt){ 
char *oldFreePt;
  oldFreePt = FreePt;
  FreePt = (char*)pt;
  *(long*)pt = (long)oldFreePt; 
}
