// filename ******** heap.h ************** 
// Prototypes for the simple heap example   

//  This example accompanies the books
//   "Embedded Microcomputer Systems: Real Time Interfacing", 
//     Thomsen, copyright (c) 2006,
//   "Introduction to Embedded Microcomputer Systems: 
//    Motorola 6811 and 6812 Simulation", Brooks-Cole, copyright (c) 2002,
//    Jonathan W. Valvano 3/21/08

// You may use, edit, run or distribute this file 
//    as long as the above copyright notices remain
#define SIZE 150      
#define NUM 10      
// 1500 bytes, 10 blocks of 150 bytes each
#define null 0



//*************Heap_Init***************
// partition the heap into NUM blocks of SIZE bytes
// heap will leave the heap empty 
// Inputs: none
// Outputs: none
// errors: this will destroy any data previously allocated
// You should call this function exactly once at the start
void Heap_Init(void);

//*************Heap_Allocate***************
// allocate 1 block of SIZE bytes
// Inputs: none
// Outputs: pointer to block of BYTE bytes
// errors: returns NULL pointer if heap was empty
void *Heap_Allocate(void);


//*************Heap_Release***************
// release 1 block of SIZE bytes back to heap
// Inputs: pointer to block of BYTE bytes
// Outputs: pointer to block of BYTE bytes
// errors: it does not check to make sure the pointer is valid
void Heap_Release(void *pt);