// filename ******** Main.C ************** 
// Example main program for the simple heap example   

//  This example accompanies the books
//   "Embedded Microcomputer Systems: Real Time Interfacing", 
//     Thomsen, copyright (c) 2006,
//   "Introduction to Embedded Microcomputer Systems: 
//    Motorola 6811 and 6812 Simulation", Brooks-Cole, copyright (c) 2002,
//    Jonathan W. Valvano 3/21/08

// You may use, edit, run or distribute this file 
//    as long as the above copyright notices remain

#include <hidef.h>      /* common defines and macros */
#include <mc9s12c32.h>     /* derivative information */
#pragma LINK_INFO DERIVATIVE "mc9s12c32"

#include "heap.h"

unsigned char *Pt1;
unsigned char *Pt2;
unsigned char *Pt3;
unsigned char *Pt4;
unsigned short *Pt5;
unsigned short *Pt6;
unsigned short *Pt7;
unsigned short *Pt8;

void main(void) {
  Heap_Init();
  EnableInterrupts;
  Pt1 = (unsigned char *)Heap_Allocate();
  Pt2 = (unsigned char *)Heap_Allocate();
  for(;;) {
    Pt3 = (unsigned char *)Heap_Allocate();
    Pt4 = (unsigned char *)Heap_Allocate();
    Pt5 = (unsigned short *)Heap_Allocate();
    Pt6 = (unsigned short *)Heap_Allocate();
    Pt7 = (unsigned short *)Heap_Allocate();
    Pt8 = (unsigned short *)Heap_Allocate();
    Heap_Release(Pt4);
    Heap_Release(Pt8);
    Heap_Release(Pt3);
    Heap_Release(Pt7);
    Heap_Release(Pt6);
    Heap_Release(Pt5);
  } 
}
